//---------------------------------------------------------------------------

#ifndef ListManDlgsH
#define ListManDlgsH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include <ImgList.hpp>
#include <ToolWin.hpp>
#include <Menus.hpp>
//---------------------------------------------------------------------------

bool __fastcall ManageMail2newsTxt(TForm *Owner, const AnsiString &FileName);
bool __fastcall ManageNymserverAsc(TForm *Owner, const AnsiString &FileName);

class TListManDlg : public TForm
{
__published:	// IDE-managed Components
        TToolBar *ToolBar;
        TPanel *Panel1;
        TRichEdit *Editor;
        TButton *OkBtn;
        TButton *CancelBtn;
        TToolButton *CutBtn;
        TToolButton *CopyBtn;
        TToolButton *PasteBtn;
        TToolButton *Spacer1;
        TToolButton *HttpBtn;
        TToolButton *Spacer2;
        TImageList *Images;
        TImageList *Imageshot;
        TImageList *Imagesdis;
        TPopupMenu *PopupMenu;
        TMenuItem *PopCutItem;
        TMenuItem *PopCopyItem;
        TMenuItem *PopPasteItem;
        TLabel *Label1;
        void __fastcall FormCloseQuery(TObject *Sender, bool &CanClose);
        void __fastcall EditorSelectionChange(TObject *Sender);
        void __fastcall PopupMenuPopup(TObject *Sender);
private:	// User declarations
public:		// User declarations
        AnsiString filename;
        TStringList *list;
        virtual __fastcall TListManDlg(TComponent* Owner);
        virtual __fastcall TListManDlg(TComponent* Owner, const AnsiString &FileName);
        virtual __fastcall~TListManDlg();
        void __fastcall SetToolbarButtons();
};
//---------------------------------------------------------------------------
extern PACKAGE TListManDlg *ListManDlg;
//---------------------------------------------------------------------------
#endif
