//---------------------------------------------------------------------------

#ifndef NymFrames2H
#define NymFrames2H
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ComCtrls.hpp>
#include <Menus.hpp>
#include <ToolWin.hpp>
#include <ExtCtrls.hpp>

#include "..\QS\QSFrames.h"
#include "Global2.h"
#include "pgpsdk.h"
//class TNymsFrame2;
//---------------------------------------------------------------------------

TQSFrame* PACKAGE __fastcall OpenNymsFrame2(TForm *Owner, TPanel *Parent, const AnsiString &Path,
   TGlobal *Global);

void PACKAGE __fastcall DeleteNymsFrame2(TQSFrame *Frame);

class PACKAGE TNymsFrame2 : public TQSFrame
{
__published:	// IDE-managed Components
        TToolButton *ToolButton1;
        TToolButton *ToolButton2;
        TToolButton *NewBtn;
        TToolButton *OpenBtn;
        TToolButton *PrintBtn;
        TToolButton *DeleteBtn;
        TToolButton *ToolButton8;
        TToolButton *ToolButton9;
        TToolButton *ToolButton10;
        TToolButton *ToolButton11;
        TToolButton *ToolButton12;
        TToolButton *ToolButton13;
        TToolButton *ToolButton14;
        TToolButton *ViewBtn;
        TListView *ListView;
        TMenuItem *NymsMenu;
        TMenuItem *NymsNewItem;
        TMenuItem *NymsOpenItem;
        TMenuItem *N2;
        TMenuItem *NymsRetireItem;
        TMenuItem *NymsDeleteItem;
        TMenuItem *NymsSelectAllItem;
        TMenuItem *NymsPrintItem;
        TMenuItem *N3;
        TMenuItem *ViewRetiredItem;
        TMenuItem *N4;
        TPopupMenu *PopNymsMenu;
        TMenuItem *New1;
        TMenuItem *Open1;
        TMenuItem *N5;
        TMenuItem *SelectAll1;
        TMenuItem *Print1;
        TMenuItem *N9;
        TMenuItem *Delete1;
        TMenuItem *Retire1;
        TTimer *Timer2;
        TMenuItem *MessageCreateItem;
        TMenuItem *MessageModifyItem;
        TMenuItem *MessageDeleteItem;
        TMenuItem *N11;
        TMenuItem *MessageReplayItem;
        TMenuItem *N13;
        TMenuItem *MessageFrmNymItem;
        TMenuItem *NymserverManager1;
        TMenuItem *Mail2newsManager1;
        TMenuItem *Updaterlisttxt1;
        TMenuItem *N14;
        TMenuItem *N15;
        TMenuItem *Nymreports1;
        TMenuItem *Finger1;
        void __fastcall NymsNewItemClick(TObject *Sender);
        void __fastcall NymsSelectAllItemClick(TObject *Sender);
        void __fastcall NymsPrintItemClick(TObject *Sender);
        void __fastcall NymsDeleteItemClick(TObject *Sender);
        void __fastcall NymsRetireItemClick(TObject *Sender);
        void __fastcall NymsOpenItemClick(TObject *Sender);
        void __fastcall ListViewChange(TObject *Sender, TListItem *Item,
          TItemChange Change);
        void __fastcall ViewMenuClick(TObject *Sender);
        void __fastcall ViewRetiredItemClick(TObject *Sender);
        void __fastcall NymsMenuClick(TObject *Sender);
        void __fastcall Timer2Timer(TObject *Sender);
        void __fastcall MessageCreateItemClick(TObject *Sender);
        void __fastcall MessageModifyItemClick(TObject *Sender);
        void __fastcall MessageDeleteItemClick(TObject *Sender);
        void __fastcall MessageMenuClick(TObject *Sender);
        void __fastcall MessageReplayItemClick(TObject *Sender);
        void __fastcall MessageFrmNymItemClick(TObject *Sender);
        void __fastcall NymserverManager1Click(TObject *Sender);
        void __fastcall Mail2newsManager1Click(TObject *Sender);
        void __fastcall ListViewCustomDrawItem(TCustomListView *Sender,
          TListItem *Item, TCustomDrawState State, bool &DefaultDraw);
        void __fastcall Updaterlisttxt1Click(TObject *Sender);
        void __fastcall Nymreports1Click(TObject *Sender);
        void __fastcall Finger1Click(TObject *Sender);
        void __fastcall ListViewMouseMove(TObject *Sender,
          TShiftState Shift, int X, int Y);
private:	// User declarations
public:		// User declarations
        TPGPsdk *PGP;
        bool GotRetired, Wait;
        __fastcall virtual TNymsFrame2(TComponent *Owner);
        __fastcall virtual TNymsFrame2(TComponent *Owner, TPanel *Parent, const AnsiString &Path);
        __fastcall virtual~TNymsFrame2();

        void __fastcall NewNym();
        void __fastcall OpenSelectedNym();
        void __fastcall OpenNym(AnsiString Nym);
        void __fastcall DeleteSelectedNyms();
        void __fastcall DeleteNym(const AnsiString &Nym);
        void __fastcall RetireSelectedNyms();
        void __fastcall RetireNym(const AnsiString &Nym);
        bool __fastcall IsRetired(const AnsiString &Nym);
        AnsiString __fastcall GetNymIndexStr(TListItem *item);
        void __fastcall SelectNymByName(const AnsiString &Nym);
      //bool __fastcall SecureMode();
        bool __fastcall CanRetire();

        int  __fastcall DataTypeImageIndex(TDataType Type);
        void __fastcall LoadIndex(AnsiString path);
        void __fastcall SetNymButtons();
        void __fastcall SelectAll();
        void __fastcall Print();
};

//---------------------------------------------------------------------------
extern PACKAGE TNymsFrame2 *NymsFrame2;
//---------------------------------------------------------------------------
#endif
