//---------------------------------------------------------------------------

#ifndef NymPrintDlgsH
#define NymPrintDlgsH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>

#include "NymFrames2.h"
#include <ExtCtrls.hpp>
//---------------------------------------------------------------------------

void __fastcall PrintNyms(TForm *Owner, TNymsFrame2 *NymFrame);

class TNymPrintDlg : public TForm
{
__published:	// IDE-managed Components
        TButton *OkBtn;
        TButton *CancelBtn;
        TCheckBox *SelectedBox;
        TCheckBox *ReplayBox;
        TCheckBox *LogBox;
        TCheckBox *NotesBox;
        TCheckBox *HistoryBox;
        TRadioButton *CurrentBox;
        TRadioButton *AllBox;
        TBevel *Bevel1;
        TCheckBox *PGPBox;
        TCheckBox *PublicBox;
        TCheckBox *SecretBox;
        void __fastcall HistoryBoxClick(TObject *Sender);
        void __fastcall FormCloseQuery(TObject *Sender, bool &CanClose);
        void __fastcall PGPBoxClick(TObject *Sender);
        void __fastcall PublicBoxClick(TObject *Sender);
        void __fastcall SecretBoxClick(TObject *Sender);
private:	// User declarations
public:		// User declarations
        __fastcall TNymPrintDlg(TComponent* Owner);
        virtual __fastcall ~TNymPrintDlg();
        void __fastcall PruneKey(const AnsiString &which, TStrings *history);
};
//---------------------------------------------------------------------------
extern PACKAGE TNymPrintDlg *NymPrintDlg;
//---------------------------------------------------------------------------
#endif
