//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "NymRepDlgs.h"
#include "NymWizDlgs.h"
#include "NymPrevBlkDlgs.h"
#include "NymMail.h"
#include "PGPbuffers.h"
#include "PgpFiles.h"
#include "WipeDlgs.h"
#include "view.h"
#include "global.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TNymRepDlg *NymRepDlg;
//---------------------------------------------------------------------------
bool __fastcall GenerateReplyBlocks(TForm *Owner, TStrings *Blocks, bool Preview)
{
   NymRepDlg = new TNymRepDlg(Owner, BlocksText, Preview);

   NymRepDlg->ShowModal();
   int mrResult = NymRepDlg->ModalResult;
   if (mrResult == mrOk)
      Blocks->Text = NymRepDlg->compiled->Text;

   delete NymRepDlg;

   return mrResult==mrOk;
}
//---------------------------------------------------------------------------
/*char* __fastcall GenerateReplyBlocks(TForm *Owner, char *Blocks)
{
   //if (retbuf) delete retbuf; retbuf = NULL;
   TStringList *blocks = new TStringList();
   TStringList *compiled = new TStringList();
   blocks->SetText(Blocks);
   NymRepDlg = new TNymRepDlg(Owner,blocks);
   NymRepDlg->ShowModal();
   int mrResult = NymRepDlg->ModalResult;
   if (mrResult==mrOk)
   {
      compiled->Text = NymRepDlg->compiled->Text;
      TrimNullsAfter(compiled);
      retbuf = new char[compiled->Text.Length()+1];
      strcpy(retbuf,compiled->Text.c_str());
   }
   delete NymRepDlg;
   delete compiled;
   delete blocks;
   return retbuf;
}*/
//---------------------------------------------------------------------------
// remailer/directives lists
//---------------------------------------------------------------------------
/*void __fastcall GetActiveShorts(AnsiString &rlisttxt, TStrings *shorts)
{
   shorts->Clear();
   AnsiString Short;
   bool saving = false;
   TStringList *rlist = new TStringList();
   rlist->LoadFromFile(clisttxt);
   for (int i=0; i<rlist->Count; i++)
   {
       Short = rlist->Strings[i];
       if (saving && Short.Trim().IsEmpty()) break;
       if (Short.Pos("-----------------------------------------------")==1)
       {
          saving = true;
          continue;
       }
       if (saving) shorts->Add(GetToken(0,Short," "));
   }
   delete rlist;
}
//---------------------------------------------------------------------------
void __fastcall GetAllShortLongs(AnsiString &rlisttxt, TStrings *shrtlongs)
{
   shrtlongs->Clear();
   AnsiString line,Shrt,Long;
   TStringList *rlist = new TStringList();
   rlist->LoadFromFile(clisttxt);
   for (int i=0; i<rlist->Count; i++)
   {
       line = rlist->Strings[i];
       if (line.Pos("$remailer{")==1)
       {
          Shrt = GetToken(1,line,"\"");
          Long = GetToken(1,line,"<");
          Long = GetToken(0,Long,">");
          shrtlongs->Add(Shrt+"="+Long);
       }
   }
   delete rlist;
}
//---------------------------------------------------------------------------
bool __fastcall GetCpkRemailerShortsEqualLongs(TStringList *remailers)
{
   TStringList *shrts = new TStringList();
   TStringList *shrtslongs = new TStringList();
   if (FileExists(clisttxt))
   {
      GetActiveShorts(clisttxt,shrts);
      GetAllShortLongs(clisttxt,shrtslongs);
   }
   for (int i=0; i<shrts->Count; i++)
      remailers->Add(shrts->Strings[i]+"="+shrtslongs->Values[shrts->Strings[i]]);
   delete shrtslongs;
   delete shrts;
   return remailers->Count>0;
}*/
//---------------------------------------------------------------------------

AnsiString __fastcall RemailerAddress(AnsiString &shortname, TStrings *clist)
{
   AnsiString remaddr,line;
   for (int i=0; i<clist->Count; i++)
   {
      line = clist->Strings[i];
      if (!line.Pos("$remailer{\""+shortname+"\"}")) continue;

      remaddr = GetEAddress(line);//GetToken(0,GetToken(1,line,"<"),">");
      break;
   }
   return remaddr;
}
//---------------------------------------------------------------------------

bool __fastcall GetCpkRemailerShortsEqualLongs(TStringList *remailers)
{
   remailers->Clear();
   AnsiString line,shrt,addr;
   TStringList *rems = new TStringList();
   if (FileExists(clisttxt)) rems->LoadFromFile(clisttxt);
   for (int i=0; i<rems->Count; i++)
   {
      line = rems->Strings[i];
      if (line.Pos("%")==0) continue;
      if (line.Trim().IsEmpty()) break;

      shrt = GetToken(0,line," ");
      remailers->Add(shrt+"="+RemailerAddress(shrt,rems));
   }
//view(remailers);
   return remailers->Count>0;
}
//---------------------------------------------------------------------------

bool __fastcall GetCpkRemailerLongsEqualShorts(TStringList *remailers)
{
   remailers->Clear();
   AnsiString line,shrt,addr;
   TStringList *rems = new TStringList();
   if (FileExists(clisttxt)) rems->LoadFromFile(clisttxt);
   for (int i=0; i<rems->Count; i++)
   {
      line = rems->Strings[i];
      if (line.Pos("%")==0) continue;
      if (line.Trim().IsEmpty()) break;

      shrt = GetToken(0,line," ");
      remailers->Add(RemailerAddress(shrt,rems)+"="+shrt);
   }
   return remailers->Count>0;
}
//---------------------------------------------------------------------------

bool __fastcall GetCpkRemailerLongs(TStrings *tostrings, TStrings *shrtslongs)
{
   tostrings->Clear();
   for (int i=0; i<shrtslongs->Count; i++)
      tostrings->Add(GetToken(1,shrtslongs->Strings[i],"="));
   return tostrings->Count>0;
}
//---------------------------------------------------------------------------

bool __fastcall GetCpkRemailerShorts(TStrings *tostrings, TStrings *shrtslongs)
{
   tostrings->Clear();
   for (int i=0; i<shrtslongs->Count; i++)
      tostrings->Add(GetToken(0,shrtslongs->Strings[i],"="));
   return tostrings->Count>0;
}
//---------------------------------------------------------------------------

__fastcall TNymRepDlg::TNymRepDlg(TComponent* Owner)
  : TForm(Owner)
{
}
//---------------------------------------------------------------------------

__fastcall TNymRepDlg::TNymRepDlg(TComponent* Owner, TStrings *BlocksText, bool Preview)
  : TForm(Owner)
{
   CenterDialog(this,Owner);
   blocks = new TStringList();
   blocks->Text = BlocksText->Text;
   compiled = new TStringList();
   bubble = new TStringList();
   block = new TStringList();
   leg = new TStringList();
   preview = Preview;
   Timer1->Enabled = true;
}
//---------------------------------------------------------------------------
__fastcall TNymRepDlg::~TNymRepDlg()
{
   delete leg;
   delete blocks;
   delete block;
   delete bubble;
   delete compiled;
}
//---------------------------------------------------------------------------
bool __fastcall TNymRepDlg::IsReplyHdr(AnsiString line)
{
   return line.Pos("Reply-Block:")==1;
}
//---------------------------------------------------------------------------
void __fastcall TNymRepDlg::Display(AnsiString msg, int mics)
{
   Panel1->Caption = msg;
   AppProcessMessages();
   Sleep(mics);
}
//---------------------------------------------------------------------------
bool __fastcall TNymRepDlg::GetNextReplyBlock(TStrings *blk, TStrings *blks,
   AnsiString &blkheader)
{
   blk->Clear();
   blkheader = "";
   while(blks->Count && !IsReplyHdr(blks->Strings[0])) blks->Delete(0);
   while(blks->Count)
   {
      AnsiString line = blks->Strings[0].Trim(); blks->Delete(0);
      if (line.Trim().IsEmpty() || (IsReplyHdr(line) && blk->Count)) break;
      blk->Add(line);
   }
   // dump the last line if it is users address
   if (blk->Count && blk->Strings[blk->Count-1].Pos("@")>0)
      blk->Delete(blk->Count-1);
   // set blkheader to the blocks header Reply-Block: p=0.75
   if (blk->Count) blkheader = blk->Strings[0];
   return blk->Count>0;
}
//---------------------------------------------------------------------------
AnsiString __fastcall GetNewsgroupIfPresent(TStrings *blk)
{
   AnsiString line,newsgroup="xyzxyzxyzxyz";
   for (int i=0; i<blk->Count; i++)
   {
      line = blk->Strings[i];
      if (line.LowerCase().Pos("anon-post-to: ")==1)
      {
         newsgroup = GetToken(1,line," ").Trim().LowerCase();
         break;
      }
   }
   return newsgroup;
}
//---------------------------------------------------------------------------
bool __fastcall TNymRepDlg::GetNextReplyLeg(TStrings *leg, TStrings *blk,
   AnsiString &remailername)
{
   int pos,x=0;
   leg->Clear();
   remailername = "";
   AnsiString line,newsgroup=GetNewsgroupIfPresent(blk);
//view(blk,"block");
   while (blk->Count)
   {
      line = blk->Strings[blk->Count-1].Trim();
      blk->Delete(blk->Count-1);
      if (x==0 && line.LowerCase()==newsgroup) continue;
      leg->Insert(0,line);
      if (!line.Pos(":"))
         break;
      x++;
   }
//view(leg,"leg");
   if ((pos=leg->IndexOf("##"))>=0) leg->Insert(pos,"");
   if (leg->Count)
   {
      remailername = leg->Strings[0];
      leg->Delete(0);
   }
   //delete hm;
   return leg->Count>0;
}
/*
bool __fastcall TNymRepDlg::GetNextReplyLeg(TStrings *leg, TStrings *blk,
   AnsiString &remailername)
{
   int pos,x=0;
   leg->Clear();
   remailername = "";
   AnsiString line,newsgroup = GetNewsgroupIfPresent(blk);
   while (blk->Count)
   {
      line = blk->Strings[blk->Count-1].Trim();
      blk->Delete(blk->Count-1);
      if (!line.Pos(":") && line.LowerCase()!=newsgroup)
         break;
      x++;
   }
   if ((pos=leg->IndexOf("##"))>=0) leg->Insert(pos,"");
   if (leg->Count)
   {
      remailername = leg->Strings[0];
      leg->Delete(0);
   }
   //delete hm;
   return leg->Count>0;
}
*/
//---------------------------------------------------------------------------
void __fastcall TNymRepDlg::ReplaceShortsWithAddresses()
{
   AnsiString line,dir,cur,val;
   TStringList *rems = new TStringList();
   TStringList *shrts = new TStringList();
   TStringList *longs = new TStringList();
   GetCpkRemailerShortsEqualLongs(rems);
   GetCpkRemailerShorts(shrts,rems);
   GetCpkRemailerLongs(longs,rems);
//view(rems->Text+"\n\n"+shrts->Text+"\n\n"+longs->Text,"Remailer Short-Longs");
// view(shrts);
// view(longs);
   for (int i=0; i<blocks->Count; i++)
   {
      line = blocks->Strings[i];
      if (!line.Pos(":") && !line.Pos("@"))
      {
         val = rems->Values[line];
         if (!val.IsEmpty()) blocks->Strings[i] = val;
         continue;
      }
      if (line.Pos("-To: "))
      {
         dir = GetToken(0,line," ");
         cur = GetToken(1,line," ");
         val = rems->Values[cur];
         if (!val.IsEmpty()) blocks->Strings[i] = dir+" "+val;
         continue;
      }
   }
   delete longs;
   delete shrts;
   delete rems;
}
//---------------------------------------------------------------------------
bool __fastcall TNymRepDlg::ValidRemailerName(AnsiString &remname, TPGPbuffer *cpkkeys)
{
   if (remname.Pos("Reply-Block:")==1) return true;
   if (remname.Pos("@")==0)
   {
      MsgBoxHwnd(Handle,
         "Invalid remailer name: "+remname,
         "Name Error",
          MB_OK
      );
      return false;
   }
   if (cpkkeys->getidtext8(remname.LowerCase()).IsEmpty())
   {
      MsgBoxHwnd(Handle,
         "I was unable to find a PGP key for "+remname+"!",
         "PGP Error",
         MB_OK
      );
      return false;
   }
   return true;
}
//---------------------------------------------------------------------------
int __fastcall GetLegCount(TStrings *block)
{
   int c=1;
   for (int i=1; i<block->Count; i++)
      if (block->Strings[i].Pos(":")==0) c++;
   return c;
}
//---------------------------------------------------------------------------
bool __fastcall ReformatLegWithHeaders(TStrings *Leg)
{
   bool yep=false;
   TStringList *leg,*hdrs,*Drts,*lines;
   leg = new TStringList();
   hdrs = new TStringList();
   Drts = new TStringList(); GetCpkDirectives(Drts);
   lines = new TStringList(); lines->Text = Leg->Text;
   while(lines->Count)
   {
      AnsiString line = lines->Strings[0];
      if (line.Pos(":")==0 || Drts->IndexOf(GetToken(0,line," "))>=0) leg->Add(line);
      else hdrs->Add(line);
      lines->Delete(0);
   }
   if (hdrs->Count)
   {
      leg->Add("");
      leg->Add("##");
      leg->AddStrings(hdrs);
      yep = true;
   }
   Leg->Text = leg->Text;
   delete lines;
   delete Drts;
   delete hdrs;
   delete leg;
   return yep;
}
//---------------------------------------------------------------------------
AnsiString __fastcall GetUserIdFromAddress(TPGPbuffer *keys, AnsiString address)
{
   TStringList *uids = new TStringList();
   keys->getuserids(uids);
   for (int i=0; i<uids->Count; i++)
   {
      AnsiString uid = uids->Strings[i];
      if (uid.Pos(address)>0)
      {
         address = uid;
         break;
      }
   }
   return address;
}
//---------------------------------------------------------------------------
void __fastcall CopyDataToBuffers(BUFFER *buf,TStrings *bubble,
   BUFFER *enc, AnsiString &remname)
{
   buf_clear(buf);
   for (int i=0; i<bubble->Count; i++)
      buf_appends(buf,s(bubble->Strings[i]+"\r\n").c_str());
   buf_clear(enc);
   buf_sets(enc,remname.c_str());
}
//---------------------------------------------------------------------------
//void __fastcall CopyBubbleToBuffer(BUFFER *buf,TStrings *bubble)
//{
//   buf_clear(buf);
//   for (int i=0; i<bubble->Count; i++)
//      buf_appends(buf,s(bubble->Strings[i]+"\n").c_str());
//}
//---------------------------------------------------------------------------
int __fastcall LegCount(TStrings *replyblock)
{
   int legs=1;
   for (int i=0; i<replyblock->Count; i++)
      if (replyblock->Strings[i].Pos(":")==0) legs++;
   return legs;
}
//---------------------------------------------------------------------------
bool __fastcall TNymRepDlg::GenerateReplyBlocks()
{
   bool ek,ok=true;
   TStringList *lines = new TStringList();
   AnsiString remname,lastremname,blockhdr,tmpCpkring=GetTempFilename();
   TPGPbuffer *cpkkeys = new TPGPbuffer(PgpRemailRing(),NO_DISABLED);
   cpkkeys->SaveToFile(tmpCpkring);

   ReplaceShortsWithAddresses();
   TrimNulls(blocks);

   int blknum=0;
   BUFFER *buf=buf_new(),*uid=buf_new();
   // get individual blocks--there may be more than one
   while(ok && GetNextReplyBlock(block,blocks,blockhdr))
   {
      blknum++; Display(blockhdr,100);
//view(block,ok?"yes":"no");
      int legnum=LegCount(block)+1;
      while(ok && GetNextReplyLeg(leg,block,remname))
      {
         legnum--;
         if ((ok=ValidRemailerName(remname,cpkkeys))==false)
            break;

         ek=leg->Text.Pos("Encrypt-Key:")>0;
         ReformatLegWithHeaders(leg);
         lines->Text = bubble->Text;
         Display(remname,100);

         bubble->Clear();
         bubble->Add("::");
         bubble->AddStrings(leg);
         bubble->AddStrings(lines);
         bubble->Add("");
         bubble->Add("");
         if (ek && !(lines->Count && lines->Strings[lines->Count-1]=="**"))
         {
            bubble->Add("**");
            bubble->Add("");
         }

         if (preview)
         switch (ReplyBlockPreview(this,blknum,legnum,bubble,!block->Count,remname))
         {
            case prevFinish: preview = false; break;
            case prevCancel: return false;
         }
         // bail out when complete, the last remailer has already been encrypted to
         if (!block->Count) break;

         CopyDataToBuffers(buf,bubble,uid,remname);
         pgpresult = pgp_encrypt(PGP_ENCRYPT,buf,uid,NULL,NULL,tmpCpkring.c_str(),NULL);
         if (!(ok=pgpresult==PGP_OK)) break;

         lines->SetText((char*)buf->data);
         bubble->Clear();
         bubble->Add("");
         bubble->Add("::");
         bubble->Add("Encrypted: PGP");
         bubble->Add("");
         bubble->AddStrings(lines);
         if (ek)
         {
            bubble->Add("");
            bubble->Add("**");
         }
         lastremname = remname;
      }
      compiled->Add(blockhdr);
      compiled->AddStrings(bubble);
      bubble->Clear();
   }
   buf_free(uid); buf_free(buf);

   if (FileExists(tmpCpkring)) zapfile(tmpCpkring,3);
   Display("done",300);
   delete cpkkeys;
   delete lines;
   return ok;
}
//---------------------------------------------------------------------------
/*bool __fastcall TNymRepDlg::GenerateReplyBlocks()
{
   bool ok=true;
   AnsiString remname,blockhdr,tmpCpkring=GetTempFilename();
   TPGPbuffer *key = new TPGPbuffer;
   TStringList *lines = new TStringList();
   TStringList *hdrs = new TStringList(); GetCpkHeaders(hdrs);
   TPGPbuffer *cpkkeys = new TPGPbuffer(PgpRemailRing(),NO_DISABLED);
   cpkkeys->SaveToFile(tmpCpkring);
   ReplaceShortsWithAddresses();

   TrimNulls(blocks);
   BUFFER *buf=buf_new(),*uid=buf_new();
   // get individual blocks--there may be more than one
   while(ok && GetNextReplyBlock(block,blocks))
   {
      bool encryptkey = block->Text.Pos("Encrypt-Key:");
      // dump the last line if it is users address
      if (block->Count && block->Strings[block->Count-1].Pos("@")>0)
          block->Delete(block->Count-1);
      blockhdr = block->Strings[0];
      Display(blockhdr,100);
      TrimNulls(block);
      int l=1,legs = GetLegCount(block);
      while(ok && GetNextReplyLeg(leg,block))
      {
         l++; remname = leg->Strings[0]; leg->Delete(0);
         if ((ok=ValidRemailerName(remname,cpkkeys))==false)
            break;

         Display(remname,100);
         ReformatLegWithHeaders(leg);
         lines->Text = bubble->Text;
         // pre-formatting
         bubble->Clear();
         bubble->Add("::");
         bubble->AddStrings(leg);
         bubble->AddStrings(lines);
         if (legs==1)
         {
            bubble->Add("");
            bubble->Add("**");
            bubble->Add("");
         }
         // exit if process complete
         if (block->Count==0)
            break;

         if (l==legs)
         {
            bubble->Add("");
            bubble->Add("**");
         }

         if (preview)
         switch (ReplyBlockPreview(this,bubble))
         {
            case prevFinish: preview = false; break;
            case prevCancel: return false;
         }

         // encrypting to remailer
         buf_sets(uid,remname.c_str());
         CopyDataToBuffers(buf,bubble,uid,remname);
         pgpresult = pgp_encrypt(PGP_ENCRYPT,buf,uid,NULL,NULL,tmpCpkring.c_str(),NULL);
         if ((ok=pgpresult==PGP_OK)==false)
            break;

         lines->SetText((char*)buf->data);
         // post-formatting
         bubble->Clear();
         bubble->Add("");
         bubble->Add("::");
         bubble->Add("Encrypted: PGP");
         bubble->Add("");
         bubble->AddStrings(lines);
         bubble->Add("");
      }
      compiled->Add(blockhdr);
      compiled->AddStrings(bubble);
      bubble->Clear();
   }
   delete buf; delete uid;

   if (FileExists(tmpCpkring)) zapfile(tmpCpkring,3);
   Display("done",300);
   delete cpkkeys;
   delete hdrs;
   delete lines;
   delete key;
   return ok;
}*/
//---------------------------------------------------------------------------
void __fastcall TNymRepDlg::Timer1Timer(TObject *Sender)
{
   Timer1->Enabled = false;
   if (GenerateReplyBlocks())
   {
      compiled->Delete(compiled->Count-1);
      ModalResult = mrOk;
      return;
   }
   ModalResult = mrCancel;
}
//---------------------------------------------------------------------------
