/*
*  DelGrpsDlg.h
*  Copyright  1999-2005 by Richard Christman
*  ALL RIGHTS RESERVED
*
*  This source file is released for peer review purposes only. It is not public domain. 
*  Redistribution either in part or whole is forbidden. The sole source for QuickSilver 
*  distribution currently is http://quicksilvermail.net . You have permission to compile
*  this source for your own use.
*
*  Richard
*  --
*  R.Christman
*  quicksilver@quicksilvermail.net
*  http://quicksilvermail.net
*
*/
//---------------------------------------------------------------------------
#ifndef DelGrpsDlgH
#define DelGrpsDlgH
//---------------------------------------------------------------------------
#include <vcl\Classes.hpp>
#include <vcl\Controls.hpp>
#include <vcl\StdCtrls.hpp>
#include <vcl\Forms.hpp>
#include <vcl\ExtCtrls.hpp>
#include <vcl\ComCtrls.hpp>
//---------------------------------------------------------------------------
const AnsiString newsgroups = "Newsgroups: ";
const AnsiString references = "References: ";

bool __fastcall MassageNewsgroups(AnsiString &Groups, TComponent *Owner);

class TDelGroupsDlg : public TForm
{
__published:	// IDE-managed Components
  TListBox *ListBox1;
  TButton *OkBtn;
  TEdit *LengthEd;
  TButton *CancelBtn;
  TPanel *Panel1;
  TRichEdit *RichEdit1;
  void __fastcall ListBox1Click(TObject *Sender);
  void __fastcall FormShow(TObject *Sender);
  
  void __fastcall FormCloseQuery(TObject *Sender, bool &CanClose);
private:	// User declarations
public:		// User declarations
  int len;
  AnsiString groups;
  __fastcall TDelGroupsDlg(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern TDelGroupsDlg *DelGroupsDlg;
//---------------------------------------------------------------------------
#endif
