/*
*  HashCashM2NDlgs.h
*  Copyright  1999-2005 by Richard Christman
*  ALL RIGHTS RESERVED
*
*  This source file is released for peer review purposes only. It is not public domain. 
*  Redistribution either in part or whole is forbidden. The sole source for QuickSilver 
*  distribution currently is http://quicksilvermail.net . You have permission to compile
*  this source for your own use.
*
*  Richard
*  --
*  R.Christman
*  quicksilver@quicksilvermail.net
*  http://quicksilvermail.net
*
*/
//---------------------------------------------------------------------------
#ifndef HashCashM2NDlgsH
#define HashCashM2NDlgsH
//---------------------------------------------------------------------------
#include <vcl\Classes.hpp>
#include <vcl\Controls.hpp>
#include <vcl\StdCtrls.hpp>
#include <vcl\Forms.hpp>
#include <vcl\ExtCtrls.hpp>
#include <vcl\Dialogs.hpp>
#include <vcl\ComCtrls.hpp>
//---------------------------------------------------------------------------
bool __fastcall AddHashCashM2N(TForm *Owner, AnsiString &gateway, AnsiString &resource,
   int &validity, AnsiString &dbname);
bool __fastcall ModHashCashM2N(TForm *Owner, AnsiString &gateway, AnsiString &resource,
   int &validity, AnsiString &dbname);

class THashCashM2NDlg : public TForm
{
__published:	// IDE-managed Components
        TEdit *GateWay;
        TEdit *Resource;
        TButton *OkBtn;
        TButton *CancelBtn;
        TLabel *Label1;
        TLabel *Label2;
        TBevel *Bevel1;
        TEdit *DBName;
        TLabel *Label3;
        TButton *BrowseBtn;
        TOpenDialog *OpenDialog1;
        TLabel *Label4;
        TEdit *Validity;
        TUpDown *UpDown1;
        void __fastcall FormCloseQuery(TObject *Sender, bool &CanClose);
        void __fastcall BrowseBtnClick(TObject *Sender);
private:	// User declarations
public:		// User declarations
        __fastcall THashCashM2NDlg(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern THashCashM2NDlg *HashCashM2NDlg;
//---------------------------------------------------------------------------
#endif
