/*
*  MixProbWins2.h
*  Copyright  1999-2005 by Richard Christman
*  ALL RIGHTS RESERVED
*
*  This source file is released for peer review purposes only. It is not public domain. 
*  Redistribution either in part or whole is forbidden. The sole source for QuickSilver 
*  distribution currently is http://quicksilvermail.net . You have permission to compile
*  this source for your own use.
*
*  Richard
*  --
*  R.Christman
*  quicksilver@quicksilvermail.net
*  http://quicksilvermail.net
*
*/
//---------------------------------------------------------------------------
#ifndef MixProbWins2H
#define MixProbWins2H
//---------------------------------------------------------------------------
#include <vcl\Classes.hpp>
#include <vcl\Controls.hpp>
#include <vcl\StdCtrls.hpp>
#include <vcl\Forms.hpp>
#include <vcl\ExtCtrls.hpp>
#include "explbtn.hpp"
#include <vcl\ComCtrls.hpp>
#include <vcl\Menus.hpp>
#include "MixKeyWins2.h"
//---------------------------------------------------------------------------
void __fastcall OpenMixProblems(AnsiString &filename);

class TMixProbWin2 : public TMixKeyWin2
{
__published:	// IDE-managed Components
	TOfficeButton *TransferBtn;
	TPopupMenu *PopupMenu3;
	TMenuItem *TransferKeyItem;
	TMenuItem *TransferKeysItem;
	void __fastcall FormResize(TObject *Sender);
	void __fastcall TransferKeysItemClick(TObject *Sender);
	void __fastcall TransferKeyItemClick(TObject *Sender);
	void __fastcall FormCloseQuery(TObject *Sender, bool &CanClose);
	void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
	void __fastcall HelpBtnClick(TObject *Sender);
	void __fastcall ClearAllBtnClick(TObject *Sender);
	void __fastcall PopupMenu3Popup(TObject *Sender);
	void __fastcall OkBtnClick(TObject *Sender);
	void __fastcall FormShow(TObject *Sender);
	void __fastcall DeleteBtnClick(TObject *Sender);
private:	// User declarations
public:		// User declarations
    AnsiString probfile;
    bool okclicked,dominimize;
    virtual __fastcall TMixProbWin2(TComponent* Owner);
    virtual __fastcall TMixProbWin2(TComponent* Owner, bool Minimized);
    virtual __fastcall TMixProbWin2(TComponent* Owner, TMixKeyList2 *Imports);
    virtual __fastcall~TMixProbWin2();
    void __fastcall DeleteKey(int atPos);
    void __fastcall SaveKeys();
    void __fastcall LoadKeys();
};
//---------------------------------------------------------------------------
extern TMixProbWin2 *MixProbWin2;
//---------------------------------------------------------------------------
#endif
