/*
*  OldOpenDlg.h
*  Copyright  1999-2005 by Richard Christman
*  ALL RIGHTS RESERVED
*
*  This source file is released for peer review purposes only. It is not public domain. 
*  Redistribution either in part or whole is forbidden. The sole source for QuickSilver 
*  distribution currently is http://quicksilvermail.net . You have permission to compile
*  this source for your own use.
*
*  Richard
*  --
*  R.Christman
*  quicksilver@quicksilvermail.net
*  http://quicksilvermail.net
*
*/
#define _WINSOCKAPI_
//---------------------------------------------------------------------------
#ifndef OldOpenDlgH
#define OldOpenDlgH
//---------------------------------------------------------------------------
#include <vcl\Classes.hpp>
#include <vcl\Controls.hpp>
#include <vcl\StdCtrls.hpp>
#include <vcl\Forms.hpp>
#include <vcl\Menus.hpp>
#include <vcl\ExtCtrls.hpp>
#include <vcl\ComCtrls.hpp>
//---------------------------------------------------------------------------
const int MultiCol=3;

AnsiString __fastcall OpenOpenDlg(TStrings *Message, AnsiString &Section,
   bool SortView=true);

class TOpenForm : public TForm
{
__published:	// IDE-managed Components
	TPanel *Panel1;
	TLabel *Label1;
	TPanel *Panel2;
	TLabel *Label2;
	TEdit *Name;
	TButton *OkBtn;
	TButton *CancelBtn;
	TPanel *Panel3;
	TImageList *ImageList1;
	TComboBox *LookInBox;
	TPopupMenu *PopupMenu;
	TMenuItem *PopDeleteItems;
	TMenuItem *PopRenameItem;
        TListView *ListView;
	
	
	void __fastcall PopupMenuPopup(TObject *Sender);
    void __fastcall PopDeleteItemsClick(TObject *Sender);
    void __fastcall PopRenameItemClick(TObject *Sender);
    void __fastcall FormCloseQuery(TObject *Sender, bool &CanClose);
    void __fastcall LookInBoxChange(TObject *Sender);
	void __fastcall FormShow(TObject *Sender);
	
	
        void __fastcall ListViewClick(TObject *Sender);
        
        void __fastcall ListViewDblClick(TObject *Sender);
private:	// User declarations
public:	// User declarations
    AnsiString mode;   // "Open " or "Save "
	__fastcall TOpenForm(TComponent* Owner);
	void __fastcall Init(AnsiString &Section);
    AnsiString __fastcall DatSection() { return LookInBox->Text; }
    AnsiString __fastcall Title();
    void __fastcall LoadItems();
};
//---------------------------------------------------------------------------
extern TOpenForm *OpenForm;
//---------------------------------------------------------------------------
#endif
