/*
*  SecUrgentDlgs.cpp
*  Copyright  1999-2005 by Richard Christman
*  ALL RIGHTS RESERVED
*
*  This source file is released for peer review purposes only. It is not public domain. 
*  Redistribution either in part or whole is forbidden. The sole source for QuickSilver 
*  distribution currently is http://quicksilvermail.net . You have permission to compile
*  this source for your own use.
*
*  Richard
*  --
*  R.Christman
*  quicksilver@quicksilvermail.net
*  http://quicksilvermail.net
*
*/
//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "SecUrgentDlgs.h"
#include "global.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TSecUrgentDlg *SecUrgentDlg;
//---------------------------------------------------------------------------

const AnsiString smurgentmsg = "\
I have found that the Secure Mode flag, in the QS database indicates that the \
program should be operating in Secure Mode yet the database was not encrypted. \
More than likely QS has just bombed out on you, or in some other way exited \
abnormally. I've just set the flag to cancel Secure Mode. \n\n\
I assume you will want to reinstate Secure Mode. Do so by clicking the Secure \
Mode button below and entering your password again.";

//---------------------------------------------------------------------------
bool __fastcall ShowSecureModeUrgent(TForm *Owner)
{
   SecUrgentDlg = new TSecUrgentDlg(Owner);
   SecUrgentDlg->ShowModal();
   bool ok = SecUrgentDlg->ModalResult==mrOk;
   delete SecUrgentDlg;
   return ok;
}
//---------------------------------------------------------------------------
__fastcall TSecUrgentDlg::TSecUrgentDlg(TComponent* Owner)
	: TForm(Owner)
{
   RichEdit1->Lines->Text = smurgentmsg;
   CenterDialog(this,(TForm*)Owner);
}
//---------------------------------------------------------------------------
