/*
*  deldocsdlg.h
*  Copyright  1999-2005 by Richard Christman
*  ALL RIGHTS RESERVED
*
*  This source file is released for peer review purposes only. It is not public domain. 
*  Redistribution either in part or whole is forbidden. The sole source for QuickSilver 
*  distribution currently is http://quicksilvermail.net . You have permission to compile
*  this source for your own use.
*
*  Richard
*  --
*  R.Christman
*  quicksilver@quicksilvermail.net
*  http://quicksilvermail.net
*
*/
//---------------------------------------------------------------------------
#ifndef DelDocsDlgH
#define DelDocsDlgH
//---------------------------------------------------------------------------
#include <vcl\Classes.hpp>
#include <vcl\Controls.hpp>
#include <vcl\StdCtrls.hpp>
#include <vcl\Forms.hpp>
#include <vcl\ComCtrls.hpp>
#include <vcl\ExtCtrls.hpp>
//---------------------------------------------------------------------------
AnsiString __fastcall ClearChosenDocuments(TForm *Owner);
AnsiString __fastcall OpenChosenDocuments(TForm *Owner);

class TRemailerDocsDlg : public TForm
{
__published:	// IDE-managed Components
  TButton *OkBtn;
  TButton *CancelBtn;
  TButton *HelpBtn;
  TPanel *Panel2;
  TGroupBox *GroupBox1;
  TBevel *Bevel1;
  TCheckBox *MlistBox;
  TCheckBox *MRingBox;
  TCheckBox *Type2Box;
  TCheckBox *ClistBox;
  TCheckBox *CRingBox;
  TCheckBox *CTyp1Box;
  TBevel *Bevel2;
  TLabel *Label1;
  void __fastcall FormCloseQuery(TObject *Sender, bool &CanClose);
  void __fastcall HelpBtnClick(TObject *Sender);
private:	// User declarations
public:		// User declarations
  AnsiString files;
  __fastcall TRemailerDocsDlg(TComponent* Owner);
};

const int otag = 1;
class TOpenDocsDlg : public TRemailerDocsDlg
{
public:
   __fastcall TOpenDocsDlg(TComponent *Owner);
};

const int dtag = 2;
class TDeleteDocsDlg : public TRemailerDocsDlg
{
public:
   __fastcall TDeleteDocsDlg(TComponent *Owner);
};
//---------------------------------------------------------------------------
extern TRemailerDocsDlg *RemailerDocsDlg;
extern TDeleteDocsDlg *DeleteDocsDlg;
extern TOpenDocsDlg *OpenDocsDlg;
//---------------------------------------------------------------------------
#endif
