/*
*  pool.h
*  Copyright  1999-2005 by Richard Christman
*  ALL RIGHTS RESERVED
*
*  This source file is released for peer review purposes only. It is not public domain. 
*  Redistribution either in part or whole is forbidden. The sole source for QuickSilver 
*  distribution currently is http://quicksilvermail.net . You have permission to compile
*  this source for your own use.
*
*  Richard
*  --
*  R.Christman
*  quicksilver@quicksilvermail.net
*  http://quicksilvermail.net
*
*/
//---------------------------------------------------------------------------
#ifndef PoolH
#define PoolH
//---------------------------------------------------------------------------
int  __fastcall QSPoolNext();
void __fastcall QSPoolClear();
int  __fastcall QSPoolCount();
const AnsiString QSPoolKey = "QSPoolKey";
int  __fastcall QSPoolRemove(AnsiString &Name);
int  __fastcall QSPoolAdd(TStrings *Msg, AnsiString &Name);
int  __fastcall QSPoolGet(TStrings *Msg, AnsiString &Name, bool Remove=true);
bool __fastcall QSPoolHeaderToClearText(int &ClearText, TStrings *msg);
bool __fastcall QSPoolClearTextToHeader(TStrings *msg, int ClearText);
int  __fastcall QSPoolHeaderToClearText(TStrings *msg);
const AnsiString ClrTextHdr = "Clear-Text: ";
#endif
