/*
*  NewsProfDlgs2.h
*  Copyright  1999-2006 by Richard Christman
*  ALL RIGHTS RESERVED
*
*  This source file is released for peer review purposes only. It is not public domain. 
*  Redistribution either in part or whole is forbidden. The sole source for QuickSilver 
*  distribution currently is http://quicksilvermail.net . You have permission to compile
*  this source for your own use.
*
*  Richard
*  --
*  R.Christman
*  quicksilver@quicksilvermail.net
*  http://quicksilvermail.net
*
*/
//---------------------------------------------------------------------------
#ifndef NewsProfDlgs2H
#define NewsProfDlgs2H
//---------------------------------------------------------------------------
#include <vcl\Classes.hpp>
#include <vcl\Controls.hpp>
#include <vcl\StdCtrls.hpp>
#include <vcl\Forms.hpp>
#include <vcl\ExtCtrls.hpp>
#include <vcl\ComCtrls.hpp>
//---------------------------------------------------------------------------
bool __fastcall NewAccountProfile2(TForm *Owner, AnsiString &Acct, TStrings *ProfilesExist);
bool __fastcall EditAccountProfile2(TForm *Owner, AnsiString &Acct);

class TNewsProfDlg2 : public TForm
{
__published:	// IDE-managed Components
        TBevel *Bevel1;
        TGroupBox *GroupBox2;
        TEdit *NNTPHost;
        TGroupBox *GroupBox3;
        TLabel *Label1;
        TLabel *Label2;
        TEdit *AccountUID;
        TCheckBox *HideType;
        TEdit *Password;
        TCheckBox *Remember;
        TGroupBox *GroupBox1;
        TRichEdit *LastArticles;
        TButton *OkBtn;
        TButton *Cancel;
        TLabel *Label3;
        TButton *NextBtn;
        void __fastcall FormCloseQuery(TObject *Sender, bool &CanClose);
        
        void __fastcall LastArticlesSelectionChange(TObject *Sender);
        void __fastcall NextBtnClick(TObject *Sender);
private:	// User declarations
public:		// User declarations
        bool modified;
        TStrings *acct, *existing;
        virtual __fastcall TNewsProfDlg2(TComponent* Owner);
        virtual __fastcall TNewsProfDlg2(TComponent* Owner, AnsiString Acct);
        __fastcall ~TNewsProfDlg2();
        bool __fastcall Modified();
};
//---------------------------------------------------------------------------
extern TNewsProfDlg2 *NewsProfDlg2;
//---------------------------------------------------------------------------
#endif
