//---------------------------------------------------------------------------

#ifndef RemailerDocs2H
#define RemailerDocs2H
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <ComCtrls.hpp>
//---------------------------------------------------------------------------

class TRemailerDoc : public TObject
{
public:
   TRichEdit *ed;
   AnsiString Name;
   TStrings *Lines;
   __fastcall TRemailerDoc(TRichEdit *Doc);
   __fastcall virtual ~TRemailerDoc();
   bool __fastcall IsTooOld();
   bool __fastcall IsValid();
};

// mlist.txt
class TMixMListTxt : public TRemailerDoc
{
public:
   __fastcall TMixMListTxt(TRichEdit *Doc);
   bool __fastcall IsVersion2();
   bool __fastcall IsTooOld();
   bool __fastcall IsValid();
};

// pubring.mix
class TMixPubringMix : public TRemailerDoc
{
public:
   __fastcall TMixPubringMix(TRichEdit *Doc);
   bool __fastcall IsTooOld();
   bool __fastcall IsValid();
};

// type2.list
class TMixType2List : public TRemailerDoc
{
public:
   __fastcall TMixType2List(TRichEdit *Doc);
   bool __fastcall IsTooOld();
   bool __fastcall IsValid();
};

// rlist.txt
class TCpkRListTxt : public TRemailerDoc
{
public:
   __fastcall TCpkRListTxt(TRichEdit *Doc);
   bool __fastcall IsVersion2();
   bool __fastcall IsTooOld();
   bool __fastcall IsValid();
};

// pubring.asc
class TCpkPubringAsc : public TRemailerDoc
{
public:
   __fastcall TCpkPubringAsc(TRichEdit *Doc);
   bool __fastcall IsTooOld();
   bool __fastcall IsValid();
};

// advisory.txt
class TQSAdvisoryTxt : public TRemailerDoc
{
public:
   __fastcall TQSAdvisoryTxt(TRichEdit *Doc);
   bool __fastcall IsTooOld();
   bool __fastcall IsValid();
};

// statsurls.txt
class TQSUrlsTxt : public TRemailerDoc
{
public:
   __fastcall TQSUrlsTxt(TRichEdit *Doc);
   bool __fastcall IsTooOld();
   bool __fastcall IsValid();
};

// nymservers.asc
class TQSNymServerAsc : public TRemailerDoc
{
public:
   __fastcall TQSNymServerAsc(TRichEdit *Doc);
   bool __fastcall IsTooOld();
   bool __fastcall IsValid();
};

// fromhead.txt
class TQSFromHeadTxt : public TRemailerDoc
{
public:
   __fastcall TQSFromHeadTxt(TRichEdit *Doc);
   bool __fastcall IsTooOld();
   bool __fastcall IsValid();
};
//---------------------------------------------------------------------------
#endif
