//---------------------------------------------------------------------------

#ifndef StatsWins2H
#define StatsWins2H
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "SHDocVw_OCX.h"
#include <Buttons.hpp>
#include <ExtCtrls.hpp>
#include <Menus.hpp>
#include <OleCtrls.hpp>
//---------------------------------------------------------------------------
void __fastcall DownloadURL(TForm *Owner, const AnsiString &Title, const AnsiString &URL,
   bool AutoSave);

class TStatsWin2 : public TForm
{
__published:	// IDE-managed Components
        TMainMenu *MainMenu1;
        TMenuItem *FileMenu;
        TMenuItem *FileOpenItem;
        TMenuItem *FileSaveItem;
        TMenuItem *N2;
        TMenuItem *Exit1;
        TPanel *Panel1;
        TSpeedButton *GetBtn;
        TLabel *Label1;
        TSpeedButton *SaveBtn;
        TComboBox *URLBox;
        TCppWebBrowser *Browser;
        TSpeedButton *CancelBtn;
        TBevel *Bevel1;
        TBevel *Bevel2;
        TTimer *Timer1;
        TTimer *Timer2;
        void __fastcall CancelBtnClick(TObject *Sender);
        void __fastcall BrowserNavigateError(TObject *Sender,
          LPDISPATCH pDisp, Variant *URL, Variant *Frame,
          Variant *StatusCode, VARIANT_BOOL *Cancel);
        void __fastcall FileOpenItemClick(TObject *Sender);
        void __fastcall Timer1Timer(TObject *Sender);
        void __fastcall BrowserDownloadComplete(TObject *Sender);
        void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
        void __fastcall FileSaveItemClick(TObject *Sender);
        void __fastcall GetBtnClick(TObject *Sender);
        void __fastcall Exit1Click(TObject *Sender);
        void __fastcall Timer2Timer(TObject *Sender);
private:	// User declarations
public:		// User declarations
        AnsiString Cap, PlainText;
        bool GotError, Cancel, AutoSave;
        __fastcall TStatsWin2(TComponent* Owner);
        void __fastcall GetURL(const AnsiString &Title, const AnsiString &URL,
           bool AutoSave);
};

//---------------------------------------------------------------------------
extern PACKAGE TStatsWin2 *StatsWin2;
//---------------------------------------------------------------------------
#endif
