//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "global2.h"
#include "RBLtDlgs.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TRBLtDlg *RBLtDlg;
//---------------------------------------------------------------------------

bool __fastcall OpenLatentTimeDialog(TForm *Owner, AnsiString &LatentTime)
{
   AnsiString newtime = LatentTime;

   RBLtDlg = new TRBLtDlg(Owner);
   RBLtDlg->LatentTime->Text = LatentTime;

   RBLtDlg->ShowModal();

   bool ok = RBLtDlg->ModalResult == mrOk;
   if (ok)
   {
      LatentTime = RBLtDlg->LatentTime->Text;
   }

   delete RBLtDlg;
   return ok;
}
//---------------------------------------------------------------------------

__fastcall TRBLtDlg::TRBLtDlg(TComponent* Owner)
        : TForm(Owner)
{
   TColor color;
   LoadFonts(AppIni(), NymIni, color, Font, LatentTime->Font, NULL);
   LatentTime->Color = color;
}
//---------------------------------------------------------------------------

void __fastcall TRBLtDlg::FormCloseQuery(TObject *, bool &)
{
   // TODO 1 : Needs error checking on latent-time return value
}
//---------------------------------------------------------------------------
