//---------------------------------------------------------------------------

#ifndef ViewRptsDlgsH
#define ViewRptsDlgsH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include <ImgList.hpp>
#include <Menus.hpp>
#include <ToolWin.hpp>
#include <Dialogs.hpp>
//---------------------------------------------------------------------------

void __fastcall ViewNymReport(TForm *Owner, const AnsiString &Title, TStrings *Report);

class TViewRptsDlg : public TForm
{
__published:	// IDE-managed Components
        TToolBar *ToolBar1;
        TPanel *Panel1;
        TRichEdit *Viewer;
        TButton *CloseBtn;
        TPopupMenu *PopupMenu;
        TMenuItem *PopCopyItem;
        TMenuItem *PopCutItem;
        TMenuItem *PopPasteItem;
        TMenuItem *N1;
        TMenuItem *PopSelectAllItem;
        TMenuItem *N2;
        TMenuItem *rdwrap1;
        TToolButton *CutBtn;
        TToolButton *CopyBtn;
        TToolButton *PasteBtn;
        TToolButton *ToolButton4;
        TToolButton *PrintBtn;
        TImageList *Images;
        TImageList *ImagesHot;
        TImageList *ImagesDis;
        TMenuItem *N3;
        TMenuItem *PopPrintItem;
        TToolButton *ToolButton1;
        TToolButton *ToolButton2;
        TMenuItem *PopSaveItem;
        TMenuItem *N4;
        TSaveDialog *SaveDialog;
        void __fastcall PopCutItemClick(TObject *Sender);
        void __fastcall PopCopyItemClick(TObject *Sender);
        void __fastcall PopPasteItemClick(TObject *Sender);
        void __fastcall PopSelectAllItemClick(TObject *Sender);
        void __fastcall PopSaveItemClick(TObject *Sender);
        void __fastcall PopupMenuPopup(TObject *Sender);
        void __fastcall ViewerSelectionChange(TObject *Sender);
        void __fastcall PopPrintItemClick(TObject *Sender);
private:	// User declarations
public:		// User declarations
        __fastcall TViewRptsDlg(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TViewRptsDlg *ViewRptsDlg;
//---------------------------------------------------------------------------
#endif
