//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Global2.h"
#include "FullAutoDlgs.h"
#include "RBWizDlgs.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TFullAutoDlg *FullAutoDlg;
//---------------------------------------------------------------------------

bool __fastcall DoFullAutoReplyBlock(TForm *Owner, const AnsiString &Nym,
   TStrings *ReplyBlock, const AnsiString &EmailAddress,
   int ChainLength, TFont *Font)
{
   FullAutoDlg = new TFullAutoDlg(Owner);
   FullAutoDlg->EmailAddress = EmailAddress;
   FullAutoDlg->ChainLength = ChainLength;
   FullAutoDlg->ReplyBlock = ReplyBlock;
   FullAutoDlg->Nym = Nym;
   FullAutoDlg->Font->Assign(Font);
   FullAutoDlg->ShowModal();
   bool ok = FullAutoDlg->ModalResult == mrOk;
   delete FullAutoDlg;
   return ok;
}
//---------------------------------------------------------------------------

__fastcall TFullAutoDlg::TFullAutoDlg(TComponent* Owner)
        : TForm(Owner)
{
   Timer1->Enabled = true;
}
//---------------------------------------------------------------------------
void __fastcall TFullAutoDlg::Timer1Timer(TObject *Sender)
{
   Timer1->Enabled = false;
   Panel1->Caption = "...working...";
   bool ok = FullAutoReplyBlockWizard(this, Nym, ReplyBlock, EmailAddress, ChainLength);
   ModalResult = ok ? mrOk : mrCancel;
   Snooze(400);
}
//---------------------------------------------------------------------------
