/*
*  BetaTestDlgs.cpp
*  Copyright  1999-2005 by Richard Christman
*  ALL RIGHTS RESERVED
*
*  This source file is released for peer review purposes only. It is not public domain. 
*  Redistribution either in part or whole is forbidden. The sole source for QuickSilver 
*  distribution currently is http://quicksilvermail.net . You have permission to compile
*  this source for your own use.
*
*  Richard
*  --
*  R.Christman
*  quicksilver@quicksilvermail.net
*  http://quicksilvermail.net
*
*/
//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "BetaTestDlgs.h"
#include "fileman.h"
#include "global.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TBetaTestDlg *BetaTestDlg;
//---------------------------------------------------------------------------
AnsiString betamessage = "\
If you consider yourself a QuickSilver beta tester, I have added a feature \
to allow you to keep track of what changes/fixes have been made and what are \
expected to be complete in the near future. My goal is to correct bugs \
faster and release updates quicker. \n\n\
On the QS 'View' menu you'll find a new submenu named 'App History'. On this \
submenu you'll find an entry for all modules you have installed. Selecting \
one of these opens the history file for that module. Work pending is listed \
at the top under the heading 'To do:'. The most recent release infois listed \
immediately after this. \n\n\
Using this info, you can see if I received your bug report and whether it has \
been fixed. If you find nothing relating to your bug. Please report it again.";

//---------------------------------------------------------------------------
void __fastcall OpenBetaTestInfo(TForm *Owner)
{
   BetaTestDlg = new TBetaTestDlg(Owner);
   CenterDialog(BetaTestDlg,Owner);
   BetaTestDlg->ShowModal();
   if (BetaTestDlg->NotAgain->Checked)
      OPENBETATESTDIALOGSET(false);
   delete BetaTestDlg;
}
//---------------------------------------------------------------------------
__fastcall TBetaTestDlg::TBetaTestDlg(TComponent* Owner)
	: TForm(Owner)
{
   RichEdit1->Lines->Text = betamessage;
}
//---------------------------------------------------------------------------
