/*
*  ListFrame.h
*  Copyright  1999-2005 by Richard Christman
*  ALL RIGHTS RESERVED
*
*  This source file is released for peer review purposes only. It is not public domain. 
*  Redistribution either in part or whole is forbidden. The sole source for QuickSilver 
*  distribution currently is http://quicksilvermail.net . You have permission to compile
*  this source for your own use.
*
*  Richard
*  --
*  R.Christman
*  quicksilver@quicksilvermail.net
*  http://quicksilvermail.net
*
*/
//---------------------------------------------------------------------------

#ifndef ListFrameH
#define ListFrameH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <QControls.hpp>
#include <QStdCtrls.hpp>
#include <QForms.hpp>
#include <QGrids.hpp>
//---------------------------------------------------------------------------

class TQSListView : public TDrawGrid
{
private:
protected:
   void __fastcall DrawCell(long ACol, long ARow, const TRect &Rect,
      TGridDrawState State);
   virtual void __fastcall KeyDown(TObject *Sender, WORD &Key, TShiftState Shift);
   void __fastcall MouseDown(TObject *Sender, TMouseButton Button, Classes::TShiftState Shift,
      int X, int Y);
   //void __fastcall DblClick();
public:
   long Anchor;
   bool *Selected;
   AnsiString Mailbox;
   TStringList *Items;
   int LastLeftCol;
   __fastcall virtual TQSListView(TComponent *Owner);
   __fastcall virtual TQSListView(TComponent *Owner, AnsiString &BoxName);
   __fastcall virtual~TQSListView();
   //AnsiString __fastcall BoxName() { return Mailbox; };
   //AnsiString __fastcall MessageSubject(AnsiString &IndexStr);
   //AnsiString __fastcall MessageDate(AnsiString &IndexStr);
   //AnsiString __fastcall MessageWho(AnsiString &IndexStr);
   //void __fastcall OpenIndex(bool sorted);
   //void __fastcall CloseIndex();
   //void __fastcall RefreshIndex();
   //void __fastcall SetBoxPos(int pos);
   //int  __fastcall GetBoxPos();
   //long __fastcall TransferSelected(AnsiString &MailBox);
   long __fastcall DeleteSelected();
   long __fastcall ClearSelected();
   void __fastcall SetSelected(long Anchor, long ToRow=-1);
   //long __fastcall OpenSelected();
   long __fastcall GridRow(long Row); // test for validity of row--not too low or high
   long __fastcall SelCount();
   void __fastcall SelectAll();
   void __fastcall SortList(bool sorted);
 //void __fastcall TopLeftChanged(TObject *Sender);
};

class TFrame1 : public TFrame
{
__published:	// IDE-managed Components
        TDrawGrid *DrawGrid1;
private:	// User declarations
public:		// User declarations
        __fastcall TFrame1(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TFrame1 *Frame1;
//---------------------------------------------------------------------------
#endif
