/*
*  MailPoolDlgs.h
*  Copyright  1999-2005 by Richard Christman
*  ALL RIGHTS RESERVED
*
*  This source file is released for peer review purposes only. It is not public domain. 
*  Redistribution either in part or whole is forbidden. The sole source for QuickSilver 
*  distribution currently is http://quicksilvermail.net . You have permission to compile
*  this source for your own use.
*
*  Richard
*  --
*  R.Christman
*  quicksilver@quicksilvermail.net
*  http://quicksilvermail.net
*
*/
//---------------------------------------------------------------------------
#ifndef MailPoolDlgsH
#define MailPoolDlgsH
//---------------------------------------------------------------------------
#include <vcl\Classes.hpp>
#include <vcl\Controls.hpp>
#include <vcl\StdCtrls.hpp>
#include <vcl\Forms.hpp>
#include <vcl\ExtCtrls.hpp>
#include "Global.h"
//---------------------------------------------------------------------------
bool __fastcall ProcessPooledMail(TForm *Owner);

class TMailPoolDlg : public TForm
{
__published:	// IDE-managed Components
	TLabel *Label1;
	TTimer *Timer1;
	TBevel *Bevel1;
	TTimer *Timer2;
	void __fastcall Timer1Timer(TObject *Sender);
	void __fastcall Timer2Timer(TObject *Sender);
private:	// User declarations
public:		// User declarations
    AnsiString cap;
	__fastcall TMailPoolDlg(TComponent* Owner);
    void __fastcall SetProfileLastMessageNum(AnsiString &description);
    bool __fastcall MovePooledToInbox();
};

//const AnsiString AppNewsDat = AppDir+"QSnews.pool";
//---------------------------------------------------------------------------
extern TMailPoolDlg *MailPoolDlg;
//---------------------------------------------------------------------------
#endif
