/*
*  MixDupChnDlgs.h
*  Copyright  1999-2005 by Richard Christman
*  ALL RIGHTS RESERVED
*
*  This source file is released for peer review purposes only. It is not public domain. 
*  Redistribution either in part or whole is forbidden. The sole source for QuickSilver 
*  distribution currently is http://quicksilvermail.net . You have permission to compile
*  this source for your own use.
*
*  Richard
*  --
*  R.Christman
*  quicksilver@quicksilvermail.net
*  http://quicksilvermail.net
*
*/
//---------------------------------------------------------------------------
#ifndef MixDupChnDlgsH
#define MixDupChnDlgsH
//---------------------------------------------------------------------------
#include <vcl\Classes.hpp>
#include <vcl\Controls.hpp>
#include <vcl\StdCtrls.hpp>
#include <vcl\Forms.hpp>
#include <vcl\ComCtrls.hpp>
//---------------------------------------------------------------------------
bool __fastcall HasDuplicateMixChainsAfterEncrypt(TForm *Owner, TStrings *chains,
   bool &cancel, int tries);

class TMixDupChnDlg : public TForm
{
__published:	// IDE-managed Components
	TRichEdit *Msg;
        TButton *OkBtn;
        TButton *CancelBtn;
        TButton *NoBtn;
private:	// User declarations
public:		// User declarations
	__fastcall TMixDupChnDlg(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern TMixDupChnDlg *MixDupChnDlg;
const int DupRetries = 10; // set same as BrokeChnDlgs BrokeRetries
//---------------------------------------------------------------------------
#endif
