/*
*  NewNameDlgs.h
*  Copyright  1999-2005 by Richard Christman
*  ALL RIGHTS RESERVED
*
*  This source file is released for peer review purposes only. It is not public domain. 
*  Redistribution either in part or whole is forbidden. The sole source for QuickSilver 
*  distribution currently is http://quicksilvermail.net . You have permission to compile
*  this source for your own use.
*
*  Richard
*  --
*  R.Christman
*  quicksilver@quicksilvermail.net
*  http://quicksilvermail.net
*
*/
//---------------------------------------------------------------------------
#ifndef NewNameDlgsH
#define NewNameDlgsH
//---------------------------------------------------------------------------
#include <vcl\Classes.hpp>
#include <vcl\Controls.hpp>
#include <vcl\StdCtrls.hpp>
#include <vcl\Forms.hpp>
//---------------------------------------------------------------------------
AnsiString __fastcall GetMailboxName();
AnsiString __fastcall GetMailboxRename(AnsiString &Currname);

class TNewNameDlg : public TForm
{
__published:	// IDE-managed Components
	TEdit *Name;
	TLabel *Label;
	TButton *Button1;
	TButton *Button2;
	void __fastcall FormCloseQuery(TObject *Sender, bool &CanClose);
	void __fastcall FormKeyPress(TObject *Sender, char &Key);
private:	// User declarations
public:		// User declarations
    TStringList *Items;
    AnsiString OriginalName;
   	__fastcall TNewNameDlg(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern TNewNameDlg *NewNameDlg;
//---------------------------------------------------------------------------
#endif
