/*
*  NymDecDlgs2.h
*  Copyright  1999-2005 by Richard Christman
*  ALL RIGHTS RESERVED
*
*  This source file is released for peer review purposes only. It is not public domain. 
*  Redistribution either in part or whole is forbidden. The sole source for QuickSilver 
*  distribution currently is http://quicksilvermail.net . You have permission to compile
*  this source for your own use.
*
*  Richard
*  --
*  R.Christman
*  quicksilver@quicksilvermail.net
*  http://quicksilvermail.net
*
*/
//---------------------------------------------------------------------------
#ifndef NymDecDlgs2H
#define NymDecDlgs2H
//---------------------------------------------------------------------------
#include <vcl\Classes.hpp>
#include <vcl\Controls.hpp>
#include <vcl\StdCtrls.hpp>
#include <vcl\Forms.hpp>
#include <vcl\ExtCtrls.hpp>
//---------------------------------------------------------------------------

int __fastcall DecryptNymMessage2(TForm *Owner, TStrings *message);

class TNymDecDlg2 : public TForm
{
__published:	// IDE-managed Components
        TPanel *Panel1;
        TTimer *Timer1;
        void __fastcall FormShow(TObject *Sender);
        void __fastcall Timer1Timer(TObject *Sender);
private:	// User declarations
public:		// User declarations
   bool success;
   TStrings *msg;
   TStringList *nyms;
   int errorcode;
   __fastcall TNymDecDlg2(TComponent* Owner);
   virtual __fastcall ~TNymDecDlg2();
//   AnsiString __fastcall GetKey(int nym, int key);
//   AnsiString __fastcall GetPhrase(int nym, int phr);
   bool __fastcall PGPDecryptConventional(TStrings *Msg, AnsiString &password);
   bool __fastcall PGPIsConventional(TStrings *Msg);
//   void __fastcall UpdateCaption(AnsiString &updateinfo);
   bool __fastcall Decrypt(TStrings *Msg);
   void __fastcall LoadPasswords();
};
//---------------------------------------------------------------------------
extern TNymDecDlg2 *NymDecDlg2;
//---------------------------------------------------------------------------
#endif
