/*
*  PackDlg.h
*  Copyright  1999-2005 by Richard Christman
*  ALL RIGHTS RESERVED
*
*  This source file is released for peer review purposes only. It is not public domain. 
*  Redistribution either in part or whole is forbidden. The sole source for QuickSilver 
*  distribution currently is http://quicksilvermail.net . You have permission to compile
*  this source for your own use.
*
*  Richard
*  --
*  R.Christman
*  quicksilver@quicksilvermail.net
*  http://quicksilvermail.net
*
*/
//---------------------------------------------------------------------------
#ifndef PackDlgH
#define PackDlgH
//---------------------------------------------------------------------------
#include <vcl\Classes.hpp>
#include <vcl\Controls.hpp>
#include <vcl\StdCtrls.hpp>
#include <vcl\Forms.hpp>
#include <vcl\ExtCtrls.hpp>
#include "FileMan.h"
#include <vcl\ComCtrls.hpp>
//---------------------------------------------------------------------------
void __fastcall PackDatabase();

class TPackForm : public TForm
{
__published:	// IDE-managed Components
   TButton *CancelBtn;
   TButton *OkBtn;
   TPanel *Panel1;
   TLabel *Label1;
   TButton *HelpBtn;
   TRichEdit *ProgressLog;
  TLabel *Label2;
   void __fastcall FormShow(TObject *Sender);
   void __fastcall FormCloseQuery(TObject *Sender, bool &CanClose);
   void __fastcall OkBtnClick(TObject *Sender);
   void __fastcall CancelBtnClick(TObject *Sender);
  void __fastcall HelpBtnClick(TObject *Sender);
private:	// User declarations
public:		// User declarations
   int errs,items;
   AnsiString TmpDat;
   bool packed,cancel,started;
   TFileManager *frFileMan;
   TFileManager *toFileMan;
   TMemoryStream *TmpFile;
   __fastcall  TPackForm(TComponent* Owner);
   __fastcall ~TPackForm();
   void __fastcall Execute();
   void __fastcall Pack();
   void __fastcall PackIndex(AnsiString &path, TFMindex *frParent, TFMindex *toParent);
   void __fastcall Display(AnsiString &TextLine);
};
//---------------------------------------------------------------------------
extern TPackForm *PackForm;
//---------------------------------------------------------------------------
#endif
