/*
*  PgpNew.h
*  Copyright  1999-2005 by Richard Christman
*  ALL RIGHTS RESERVED
*
*  This source file is released for peer review purposes only. It is not public domain. 
*  Redistribution either in part or whole is forbidden. The sole source for QuickSilver 
*  distribution currently is http://quicksilvermail.net . You have permission to compile
*  this source for your own use.
*
*  Richard
*  --
*  R.Christman
*  quicksilver@quicksilvermail.net
*  http://quicksilvermail.net
*
*/
//---------------------------------------------------------------------------
#ifndef PgpNewH
#define PgpNewH
//---------------------------------------------------------------------------
#include <vcl\Classes.hpp>
#include <vcl\Controls.hpp>
#include <vcl\StdCtrls.hpp>
#include <vcl\Forms.hpp>
#include <vcl\ExtCtrls.hpp>
//---------------------------------------------------------------------------
int __fastcall GetNewKeyringHanding(TForm *Owner);

class TPgpNewDlg : public TForm
{
__published:	// IDE-managed Components
        TLabel *Label1;
        TRadioButton *RadioButton1;
        TRadioButton *RadioButton2;
        TRadioButton *RadioButton3;
        TButton *OkBtn;
        TLabel *Label2;
        TBevel *Bevel1;
        TBevel *Bevel2;
private:	// User declarations
public:		// User declarations
        __fastcall TPgpNewDlg(TComponent* Owner);
};

const int KRCopy = 1;
const int KRMainPGP = 2;
const int KREmpty = 3;
//---------------------------------------------------------------------------
extern TPgpNewDlg *PgpNewDlg;
//---------------------------------------------------------------------------
#endif
