/*
*  RemShortNameDlgs.h
*  Copyright  1999-2005 by Richard Christman
*  ALL RIGHTS RESERVED
*
*  This source file is released for peer review purposes only. It is not public domain. 
*  Redistribution either in part or whole is forbidden. The sole source for QuickSilver 
*  distribution currently is http://quicksilvermail.net . You have permission to compile
*  this source for your own use.
*
*  Richard
*  --
*  R.Christman
*  quicksilver@quicksilvermail.net
*  http://quicksilvermail.net
*
*/
//---------------------------------------------------------------------------
#ifndef RemShortNameDlgsH
#define RemShortNameDlgsH
//---------------------------------------------------------------------------
#include <vcl\Classes.hpp>
#include <vcl\Controls.hpp>
#include <vcl\StdCtrls.hpp>
#include <vcl\Forms.hpp>
#include <vcl\ComCtrls.hpp>
//---------------------------------------------------------------------------
bool __fastcall GetRemailerShortName(TForm *Owner, const AnsiString &RemailerAddress,
   AnsiString &ShortName);

class TRemShortNameDlg : public TForm
{
__published:	// IDE-managed Components
        TEdit *ShortName;
        TButton *OkBtn;
        TButton *CancelBtn;
        TLabel *Label3;
        TRichEdit *Message;
        TLabel *Label1;
        void __fastcall FormCloseQuery(TObject *Sender, bool &CanClose);
        void __fastcall FormShow(TObject *Sender);
private:	// User declarations
public:		// User declarations
        AnsiString OrgShortName;
        __fastcall TRemShortNameDlg(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern TRemShortNameDlg *RemShortNameDlg;
//---------------------------------------------------------------------------
#endif
