/*
*  UPDUnzipDlg.h
*  Copyright  1999-2005 by Richard Christman
*  ALL RIGHTS RESERVED
*
*  This source file is released for peer review purposes only. It is not public domain. 
*  Redistribution either in part or whole is forbidden. The sole source for QuickSilver 
*  distribution currently is http://quicksilvermail.net . You have permission to compile
*  this source for your own use.
*
*  Richard
*  --
*  R.Christman
*  quicksilver@quicksilvermail.net
*  http://quicksilvermail.net
*
*/
//---------------------------------------------------------------------------
#ifndef UPDUnzipDlgH
#define UPDUnzipDlgH
//---------------------------------------------------------------------------
#include <vcl\Classes.hpp>
#include <vcl\Controls.hpp>
#include <vcl\StdCtrls.hpp>
#include <vcl\Forms.hpp>
#include <vcl\ExtCtrls.hpp>
//---------------------------------------------------------------------------
bool __fastcall UnzipQSPlugins(TForm *Owner, AnsiString &zipfile, bool &runQS);

class TUPDunzipForm : public TForm
{
__published:	// IDE-managed Components
  TTimer *Timer1;
  TPanel *Panel1;
  TMemo *Memo1;
  TButton *OkBtn;
  TCheckBox *RunQSBox;
  TBevel *Bevel1;
  TLabel *Label2;
  void __fastcall FormShow(TObject *Sender);
  void __fastcall Timer1Timer(TObject *Sender);
  void __fastcall FormCloseQuery(TObject *Sender, bool &CanClose);
  void __fastcall OkBtnClick(TObject *Sender);
private:	// User declarations
public:		// User declarations
   bool ok;
   TStringList *output;
   AnsiString unzipper,pluginzip;
   virtual __fastcall TUPDunzipForm(TComponent* Owner);
   virtual __fastcall TUPDunzipForm(TComponent* Owner, const AnsiString &UnZipper,
      AnsiString &PluginZip);
   bool __fastcall Execute(AnsiString &UnZipper, AnsiString &PluginZip);
   bool __fastcall UnpackZipTools();
   bool __fastcall UnzipPlugins();
};
//---------------------------------------------------------------------------
extern TUPDunzipForm *UPDunzipForm;
//---------------------------------------------------------------------------
#endif
