/*
*  WelcomeDlgs.cpp
*  Copyright  1999-2005 by Richard Christman
*  ALL RIGHTS RESERVED
*
*  This source file is released for peer review purposes only. It is not public domain. 
*  Redistribution either in part or whole is forbidden. The sole source for QuickSilver 
*  distribution currently is http://quicksilvermail.net . You have permission to compile
*  this source for your own use.
*
*  Richard
*  --
*  R.Christman
*  quicksilver@quicksilvermail.net
*  http://quicksilvermail.net
*
*/
//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "WelcomeDlgs.h"
#include "coderevdlgs.h"
#include "qs1\QSver.h"
#include "global.h"
#include "copyright.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TWelcomeDlg *WelcomeDlg;
//---------------------------------------------------------------------------
bool __fastcall OpenWelcomeDialog(TForm *Owner)
{
   WelcomeDlg = new TWelcomeDlg(Owner);
   WelcomeDlg->VerLabel->Caption = AppName.Trim()+" "+ReleaseVersion.Trim();

   WelcomeDlg->CopyLabel->Caption = CopyRight;
   WelcomeDlg->ShowModal();
   bool getmix=WelcomeDlg->ModalResult==IDYES;
   delete WelcomeDlg;
   return getmix;
}
//---------------------------------------------------------------------------
__fastcall TWelcomeDlg::TWelcomeDlg(TComponent* Owner)
  : TForm(Owner)
{
   CenterDialog(this,Owner);
}
//---------------------------------------------------------------------------
void __fastcall TWelcomeDlg::FormCloseQuery(TObject *Sender, bool &CanClose)
{
   ShowCodeRevDialog(this);        
}
//---------------------------------------------------------------------------
