/*
*  importDlg.h
*  Copyright  1999-2005 by Richard Christman
*  ALL RIGHTS RESERVED
*
*  This source file is released for peer review purposes only. It is not public domain. 
*  Redistribution either in part or whole is forbidden. The sole source for QuickSilver 
*  distribution currently is http://quicksilvermail.net . You have permission to compile
*  this source for your own use.
*
*  Richard
*  --
*  R.Christman
*  quicksilver@quicksilvermail.net
*  http://quicksilvermail.net
*
*/
//---------------------------------------------------------------------------
#ifndef ImportDlgH
#define ImportDlgH
//---------------------------------------------------------------------------
#include <vcl\Classes.hpp>
#include <vcl\Controls.hpp>
#include <vcl\StdCtrls.hpp>
#include <vcl\Forms.hpp>
#include <vcl\ExtCtrls.hpp>
#include <vcl\Dialogs.hpp>
//---------------------------------------------------------------------------
bool __fastcall ImportPgpKeyrings(AnsiString &ImportFile, AnsiString &PubFile,
   AnsiString &SecFile, TForm *Owner);

class TImportDlg : public TForm
{
__published:	// IDE-managed Components
  TButton *CancelBtn;
  TGroupBox *GroupBox1;
  TRadioButton *AddnewBox;
  TRadioButton *ReplaceBox;
  TGroupBox *GroupBox2;
  TEdit *ImportFileName;
  TButton *Button1;
  TButton *HelpBtn;
  TButton *Button2;
  TLabel *Label1;
  TLabel *Label2;
  TOpenDialog *OpenImport;
  TButton *OkBtn;
  TCheckBox *DeleteBox;
  TLabel *Label3;
  void __fastcall HelpBtnClick(TObject *Sender);
  void __fastcall Button2Click(TObject *Sender);
  void __fastcall Button1Click(TObject *Sender);
  void __fastcall OkBtnClick(TObject *Sender);
  void __fastcall CancelBtnClick(TObject *Sender);
private:	// User declarations
public:		// User declarations
  AnsiString Pubring,Secring;
  __fastcall TImportDlg(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern TImportDlg *ImportDlg;
//---------------------------------------------------------------------------
#endif
