//---------------------------------------------------------------------------

#ifndef BarRemsDlgs2H
#define BarRemsDlgs2H
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>

#include "statswins4.h"
#include <Menus.hpp>
//---------------------------------------------------------------------------
bool __fastcall ManageBarredRemailers2(TQSStatsWin4 *Owner, const AnsiString &FileName);

class TBarRemsDlg2 : public TForm
{
__published:	// IDE-managed Components
        TListView *ListView;
        TBevel *Bevel1;
        TButton *EditSrcBtn;
        TLabel *Label1;
        TButton *OkBtn;
        TButton *CancelBtn;
        TPopupMenu *PopupMenu;
        TMenuItem *PopBarLastItem;
        void __fastcall ListViewAdvancedCustomDrawItem(
          TCustomListView *Sender, TListItem *Item, TCustomDrawState State,
          TCustomDrawStage Stage, bool &DefaultDraw);
        void __fastcall FormCloseQuery(TObject *Sender, bool &CanClose);
        void __fastcall EditSrcBtnClick(TObject *Sender);
        void __fastcall PopupMenuPopup(TObject *Sender);
        void __fastcall PopBarLastItemClick(TObject *Sender);
        void __fastcall ListViewMouseDown(TObject *Sender,
          TMouseButton Button, TShiftState Shift, int X, int Y);
private:	// User declarations
public:		// User declarations
        bool Modified;
        AnsiString BarFile, OrgBars;
        TStringList *BarredRemailers, *BarredLast;
        virtual __fastcall TBarRemsDlg2(TComponent* Owner);
        virtual __fastcall TBarRemsDlg2(TComponent* Owner, const AnsiString &FileName);
        virtual __fastcall~TBarRemsDlg2();
        void __fastcall GetMixmasterRemailers(TStrings *mixers);
        void __fastcall GetBarredFromListView(TStrings *Barred);
        void __fastcall LoadListView();
};
//---------------------------------------------------------------------------
extern PACKAGE TBarRemsDlg2 *BarRemsDlg2;
//---------------------------------------------------------------------------
#endif
