//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "global2.h"
#include "ChkAddKeysDlgs.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TChkAddKeysDlg *ChkAddKeysDlg;
//---------------------------------------------------------------------------

bool __fastcall CheckAddKeyrings(TForm *Owner, TStrings *pages, const AnsiString &LastSource,
   const AnsiString &NewSource)
{
   if (pages->Count == 4 || NewSource == LastSource)
      return true;

   ChkAddKeysDlg = new TChkAddKeysDlg(Owner, pages);
   ChkAddKeysDlg->Caption = " New stats source detected {" + LastSource + "->" + NewSource + "}";
   ChkAddKeysDlg->Font = Owner->Font;
   ChkAddKeysDlg->ShowModal();
   bool ok = ChkAddKeysDlg->ModalResult == mrOk;
   delete ChkAddKeysDlg;

   return ok;
}
//---------------------------------------------------------------------------

__fastcall TChkAddKeysDlg::TChkAddKeysDlg(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------

__fastcall TChkAddKeysDlg::TChkAddKeysDlg(TComponent* Owner, TStrings *Pages)
        : TForm(Owner)
{
   pages = Pages;
   for (int i = 0; i < pages->Count; i++)
   {
      if (pages->Strings[i] == "mlist.txt")
         MListBox->Checked = true;
      else if (pages->Strings[i] == "pubring.mix")
         PubringMixBox->Checked = true;
      else if (pages->Strings[i] == "rlist.txt")
         RListBox->Checked = true;
      else if (pages->Strings[i] == "pubring.asc")
         PubringAscBox->Checked = true;
   }
}
//---------------------------------------------------------------------------
void __fastcall TChkAddKeysDlg::FormCloseQuery(TObject *Sender,
      bool &CanClose)
{
   pages->Clear();
   if (MListBox->Checked)
      pages->Add("mlist.txt");
   if (PubringMixBox->Checked)
      pages->Add("pubring.mix");
   if (RListBox->Checked)
      pages->Add("rlist.txt");
   if (PubringAscBox->Checked)
      pages->Add("pubring.asc");
}
//---------------------------------------------------------------------------
