//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Global2.h"
#include "HistoryWins.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
THistoryWin *HistoryWin;
//---------------------------------------------------------------------------
                                                     
void __fastcall OpenApplicationHistory(TForm *Owner, TFont *WinFont, TColor WinColor,
   const AnsiString &HistoryFile)
{
   HistoryWin = new THistoryWin(Owner);
   HistoryWin->Caption = ExtractFileName(HistoryFile);
   HistoryWin->Viewer->Lines->LoadFromFile(HistoryFile);
   HistoryWin->Viewer->Font->Assign(WinFont);
   HistoryWin->Viewer->Color = WinColor;
   HistoryWin->Show();
}
//---------------------------------------------------------------------------

__fastcall THistoryWin::THistoryWin(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall THistoryWin::FormClose(TObject *Sender, TCloseAction &Action)
{
   Action = caFree;
}
//---------------------------------------------------------------------------
void __fastcall THistoryWin::OkBtnClick(TObject *Sender)
{
   Close();        
}
//---------------------------------------------------------------------------

