//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Global2.h"
//---------------------------------------------------------------------------
USEFORM("URLDlgs.cpp", URLDlg);
USEFORM("StatsWins4.cpp", QSStatsWin4);
USEFORM("UpdateSelectDlgs.cpp", UpdateSelectDlg);
USEFORM("StatsOptionsDlgs.cpp", StatsOptionsDlg);
USEFORM("NewMixKeyWins.cpp", NewMixKeysWin);
USEFORM("RearrangeDlgs.cpp", ReorderDlg);
USEFORM("AboutDlgs2.cpp", AboutDlg);
USEFORM("ViewBarredDlgs.cpp", ViewBarredDlg);
USEFORM("PrntSelPagesDlgs.cpp", PrntSelPagesDlg);
USEFORM("BarEditDlgs.cpp", BarEditDlg);
USEFORM("..\shared\HistoryWins.cpp", HistoryWin);
USEFORM("BarRemsDlgs2.cpp", BarRemsDlg2);
USEFORM("ChkAddKeysDlgs.cpp", ChkAddKeysDlg);
//---------------------------------------------------------------------------
WINAPI WinMain(HINSTANCE, HINSTANCE, LPSTR, int)
{
        HANDLE hWnd;
        CreateMutex(NULL, FALSE, "QSStatsWin4");
        if(GetLastError() == ERROR_ALREADY_EXISTS)
        {
           if ((hWnd = FindWindow("TQSStatsWin4", NULL)) > 0)
           {
              ShowWindow(hWnd, SW_SHOWDEFAULT);
              SetForegroundWindow(hWnd);
              return 0;
           }
        }

        WM_QSAPPMESSAGE = RegisterWindowMessage(WM_QSAppMessage.c_str());

        try
        {
                 Application->Initialize();
                 Application->CreateForm(__classid(TQSStatsWin4), &QSStatsWin4);
                 Application->Run();
        }
        catch (Exception &exception)
        {
                 Application->ShowException(&exception);
        }
        catch (...)
        {
                 try
                 {
                         throw Exception("");
                 }
                 catch (Exception &exception)
                 {
                         Application->ShowException(&exception);
                 }
        }
        return 0;
}
//---------------------------------------------------------------------------
